import path from 'path'
import chokidar from 'chokidar'
import {exec} from 'child_process'

const __dirname = new URL('.', import.meta.url).pathname


const srcDir = path.resolve(__dirname, '../src')

chokidar.watch(srcDir).on('all', async (event, filePath) => {
  console.log(`${event}: ${filePath}`)
  if (event === 'change' || event === 'add') {
    exec('npm run build', (err, stdout, stderr) => {
      if (err) console.error(err)
      console.log(stdout)
      console.error(stderr)
    })
  }
})
