import fs from 'fs'
import path from 'path'

const __dirname = new URL('.', import.meta.url).pathname

const distPath = path.resolve(__dirname, '../dist')
const targetPathList = [
  // path.resolve(__dirname, "../trtc-custom-component/src"),
  path.resolve(__dirname, '../../trtc-component-wx/miniprogram_dev/node_modules/@tencentcloud/trtc-cloud-wx'),
]

fs.readdir(distPath, (err, files) => {
  if (err) throw err
  files.forEach((file) => {
    targetPathList.forEach((targetPath) => {
      const srcPath = path.join(distPath, file)
      const destPath = path.join(targetPath, file)
      fs.copyFile(srcPath, destPath, (err) => {
        if (err) throw err
        console.log(`${file} has been copied to ${targetPath}`)
      })
    })
  })
})
