import typescript from '@rollup/plugin-typescript'
import {babel} from '@rollup/plugin-babel'
import json from '@rollup/plugin-json'


export default {
  input: 'src/index.ts',
  output: {
    file: 'dist/trtc-cloud-wx.js',
    format: 'cjs',
  },
  plugins: [
    babel({
      extensions: ['.js', '.jsx', '.es6', '.es', '.mjs', 'ts', 'tsx'],
    }),
    typescript(),
    json()
  ],
}
