export enum TRTCAppScene {
  // web
  // TRTCAppSceneVideoCall = 0,
  // TRTCAppSceneLIVE = 1,
  // TRTCAppSceneAudioCall = 2,
  // TRTCAppSceneVoiceChatRoom = 3,

  // miniprogram
  // TRTCAppSceneVideoCall = 'videocall',
  // TRTCAppSceneLIVE = 'live',
  // TRTCAppSceneAudioCall = 'audiocall',
  // TRTCAppSceneVoiceChatRoom = 'voicechatroom',
  TRTCAppSceneVideoCall = 0,
  TRTCAppSceneLIVE = 1, // live
  TRTCAppSceneAudioCall = 2,
  TRTCAppSceneVoiceChatRoom = 3,
}

export enum TRTCRoleType {
  TRTCRoleAnchor = 20,
  TRTCRoleAudience = 21,
}

export enum TRTCVideoStreamType {
  TRTCVideoStreamTypeBig = 0,
  TRTCVideoStreamTypeSmall = 1,
  TRTCVideoStreamTypeSub = 2, // aux
}

export enum TRTCVideoResolution {
  TRTCVideoResolution_120_120 = 1,
  TRTCVideoResolution_160_160 = 3,
  TRTCVideoResolution_270_270 = 5,
  TRTCVideoResolution_480_480 = 7,
  TRTCVideoResolution_160_120 = 50,
  TRTCVideoResolution_240_180 = 52,
  TRTCVideoResolution_280_210 = 54,
  TRTCVideoResolution_320_240 = 56,
  TRTCVideoResolution_400_300 = 58,
  TRTCVideoResolution_480_360 = 60,
  TRTCVideoResolution_640_480 = 62,
  TRTCVideoResolution_960_720 = 64,
  TRTCVideoResolution_160_90 = 100,
  TRTCVideoResolution_256_144 = 102,
  TRTCVideoResolution_320_180 = 104,
  TRTCVideoResolution_480_270 = 106,
  TRTCVideoResolution_640_360 = 108,
  TRTCVideoResolution_960_540 = 110,
  TRTCVideoResolution_1280_720 = 112,
  TRTCVideoResolution_1920_1080 = 114,
}

export enum TRTCVideoResolutionMode {
  TRTCVideoResolutionModeLandscape = 0,
  TRTCVideoResolutionModePortrait = 1,
}

export enum TRTCVideoRotation {
  TRTCVideoRotation0 = 0,
  TRTCVideoRotation90 = 1,
  TRTCVideoRotation180 = 2,
  TRTCVideoRotation270 = 3,
}

export enum TRTCVideoFillMode {
  TRTCVideoFillMode_Fill = 0,
  TRTCVideoFillMode_Fit = 1,
}

export enum TRTCVideoMirrorType {
  TRTCVideoMirrorType_Auto = 0,
  TRTCVideoMirrorType_Enable = 1,
  TRTCVideoMirrorType_Disable = 2,
}

export enum TRTCAudioQuality {
  /** 语音模式：采样率：16k；单声道；音频裸码率：16kbps；适合语音通话为主的场景，比如在线会议，语音通话。 */
  TRTCAudioQualitySpeech = 1,
  /** 标准模式（或者默认模式）：采样率：48k；单声道；音频裸码率：50kbps；SDK 默认的音频质量，如无特殊需求推荐选择之。 */
  TRTCAudioQualityDefault = 2,
  /** 音乐模式：采样率：48k；双声道 + 全频带；音频裸码率：128kbps；适合需要高保真传输音乐的场景，比如K歌、音乐直播等。 */
  TRTCAudioQualityMusic = 3,
}

export enum TRTCBeautyStyle {
  TRTCBeautyStyleSmooth = 0,
  TRTCBeautyStyleNature = 1,
}
